=== debian/changelog ===
seqan (1.3.1-1) unstable; urgency=low

  * New upstream version
  * debian/watch: Adapt to new way to provide release archives
  * debian/orig-tar.sh:
     - Be less noisy
     - Provide fallback target dir in case .svn/deb-layout doese not
       exist - which is the case at least in my checkout
  * debian/control:
     - Standards-Version: 3.9.3 (no changes needed)
     - distinct short descriptions
  * debian/seqan-dev.doc-base: Provide doc-base control file
  * debian/rules + several debhelper files:
    Rely more on debhelper than manual moving around files to make
    debian/rules better maintaineable
  * debian/rules:
     - Do not specify single target files but rather use find to
       obtain files to move around
     - Save a copy of those files which will be removed by upstream
       clean target otherwise to enable building twice in a row

 -- Andreas Tille <tille@debian.org>  Mon, 23 Apr 2012 13:25:17 +0200
