=== debian/control ===
Source: seqan
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Soeren Sonnenburg <sonne@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: cdbs, debhelper (>= 8), cmake, zlib1g-dev, libbam-dev, libboost-dev
Standards-Version: 3.9.3
Homepage: http://www.seqan.de/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/seqan/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/seqan/trunk/

Package: seqan-apps
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for the analysis of biological sequences
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance. This package contains the applications dfi, pair_align,
 micro_razers, seqan_tcoffee, seqcons, razers and tree_recon.

Package: seqan-dev
Section: libdevel
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for the analysis of biological sequences (development)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the developer files, documentation and examples.
