=== debian/watch ===
version=3
http://ftp.seqan.de/releases/seqan-([.\d]+)\.zip \
   debian debian/orig-tar.sh
